% 设定与课件稍有出入
var Y C K L A R W I OBS_C;
varexo eps_A;
parameters alph betta delt gam pssi rhoA sigmA;

alph = 0.35; betta = 0.99; delt = 0.025; gam = 1; pssi = 1.6; 
rhoA = 0.9226; sigmA=0.0440;

model;		
    #UC  = gam*C^(-1);
    #UCp = gam*C(+1)^(-1);
    #UL  = -pssi*(1-L)^(-1);
    UC = betta*UCp*(1-delt+R);
    W = -UL/UC;
    K = (1-delt)*K(-1)+I;
    Y = I+C;
    Y = A*K(-1)^alph*L^(1-alph);
    W = (1-alph)*Y/L;
    R = alph*Y/K(-1);
    log(A) = rhoA*log(A(-1))+eps_A;
    OBS_C=log(C)-log(C(-1));
end;

steady_state_model;
    A = 1;
    R = 1/betta+delt-1;
    K_L = ((alph*A)/R)^(1/(1-alph));
    W = (1-alph)*A*K_L^alph;
    I_L = delt*K_L;
    Y_L = A*K_L^alph;
    C_L = Y_L-I_L;
    L = gam/pssi*C_L^(-1)*W/(1+gam/pssi*C_L^(-1)*W);
    C = C_L*L;
    I = I_L*L;
    K = K_L*L;
    Y = Y_L*L;
    OBS_C=C-C;
end;

steady;

shocks;
var eps_A; stderr sigmA;
end;


stoch_simul(ar=5,drop=100,irf=40,order=2,solve_algo=4) Y C K L A R W I;

estimated_params;
//PARAMETER     ,  INITIAL VALUE  ,  LB  ,  UB  ,  PRIOR TYPE     ,  PRIOR MEAN  ,  PRIOR STDERR  
  rhoA          ,  0.9226         ,  0   ,  1   ,  beta_pdf       ,  0.9         ,  0.1           ;
  stderr eps_A  ,  0.0440         ,      ,      ,  inv_gamma_pdf  ,  0.1         ,  0.1           ;
end;

varobs OBS_C;

set_dynare_seed(1);
estimation(datafile=dataset,mh_conf_sig=0.9,mh_replic=20000,mh_nblocks=2,mode_compute=4) Y C K L A R W I;
